<!--
   Bokhandel.jsp  - "Programmering i Java", 4.utgave - 2009-07-01
   En meget enkel nettbokhandel.   
-->   

<html><head><title>Bokhandel</title></head>
<body>
<h2>Velg bker</h2>

<%@ page import="mittBibliotek.Bok, java.text.NumberFormat" %>

<%!private NumberFormat pengeformat = NumberFormat.getCurrencyInstance();
   
   /** 
    * Lager bokliste per sesjon, listen vil etterhvert inneholde
    * antallet bker kunden har bestilt i denne sesjonen.
    */
   public void genererBokliste(HttpSession session) {
     Bok[] titler = {
     new Bok("Annunziato, Kaminaris: JavaServer Pages in 24 Hours", 290),
     new Bok("Hougland and Tavistock: Core JSP", 415),
     new Bok("Pekowsky: JavaServer Pages", 375),
     new Bok("Hall: Core Servlets and JavaServer Pages", 395),
     new Bok("Bergsten: JavaServer Pages", 375)};
     session.setAttribute("bokliste", titler);
   }
%>   

<%
  if (session.getAttribute("bokliste") == null) {
    genererBokliste(session);
  }
  Bok[] titler = (Bok[]) session.getAttribute("bokliste");

  /*
   * Vi behandler de ulike situasjonene vi kan vre i nr siden skal 
   * lastes ned. Statuslinjen (linje 2 p skjermen) oppdateres. 
   * Tre tilfeller er mulig:
   * Brukeren har trykket "Nullstill ordre" eller "Oppdater status", eller
   * det er frste gang siden lastes ned i denne sesjonen.
   */
  if (request.getParameter("nullstill") != null) {
    /*
     * Nullstiller antall bestillinger
     */
    for (int i = 0; i < titler.length; i++) {
      titler[i].setAntall(0);
    }
    out.println("Ingen bker bestilt.");
    
  } else if(request.getParameter("oppdater") != null) {  
    /*
     * Kunden har gjort bestillinger, vi leser av disse og
     * oppdaterer boklisten og linjen verst p skjermen.
     */    
    double totalpris = 0.0;
    int totalantall = 0;          
    int indeks = 0;   
    try {
      String[] antallStreng = request.getParameterValues("antall");
      for (indeks = 0; indeks < antallStreng.length; indeks++) {      
        int antall = Integer.parseInt(antallStreng[indeks]);
        totalantall += antall;
        totalpris += titler[indeks].getPris() * antall;   
        titler[indeks].setAntall(antall);       
      }
      out.println("Totalt antall bker hittil: " + totalantall + ", totalpris: " + 
                                     pengeformat.format(totalpris) + ".");   
    } catch (NumberFormatException e) {
       out.println("Ugyldig tall skrevet inn for tittelen " + titler[indeks].getTittel());
    }
  }  else {
    out.println("Velkommen til bokhandelen!");  // frste gang siden lastes ned
  }
%>

<%-- 
  Vi viser fram boklisten og felter til  skrive bestillinger i.
  Nederst har vi trykknapper for oppdatering og nullstilling.
--%>

<br>
<form action = "Bokhandel.jsp" method = "post">
<table border=1>
  <tr><th>Tittel</th><th>Pris</th><th>Antall</th>
  <%
    for (Bok enTittel : titler) {
       %>
       <tr><td> <%=enTittel.getTittel()%></td>
           <td> <%=pengeformat.format(enTittel.getPris())%></td>
           <td> <input type="text" name="antall" 
                     value="<%=enTittel.getAntall()%>"></td>
       </tr>
       <%
     }
  %>
</table>  
<br>
<input type="submit" name="oppdater" value="Oppdater status">
<input type="submit" name="nullstill" value="Nullstill ordre">
</form>  
</body></html>     