/**
 * ElementListe.java - "Programmering i Java", 4.utgave - 2009-07-01
 *
 * Klassen innkapsler en lenket liste av elementer av en vilkrlig klassetype.
 * Metodene toString() og equals() m vre definert for klassen,
 * hvis ikke blir arvede utgaver av disse metodene brukt.
 */

class ElementListe<Type> {
  private ListeElement<Type> frsteElement;

  /**
   * Metoden returnerer innholdet i listen i tekstlig form.
   * Bruker toString() for klassen Type.
   */
  public String toString() {
    String listeTekst = "";
    ListeElement<Type> hjelpeReferanse = frsteElement;
    while (hjelpeReferanse != null) {
      listeTekst += hjelpeReferanse.getElement().toString() + "\n";
      hjelpeReferanse = hjelpeReferanse.getNeste();
    }
    return listeTekst;
  }

  /**
   * Setter inn et element til slutt i listen.
   */
  public void settInnElementTilSlutt(Type nyttElement) {
    ListeElement<Type> hjelpeReferanse = frsteElement;
    ListeElement<Type> hjelpeReferanseRettBak = null;
    /* Vi starter med  bevege oss fram til slutten av listen. */
    while (hjelpeReferanse != null) {
      hjelpeReferanseRettBak = hjelpeReferanse;
      hjelpeReferanse = hjelpeReferanse.getNeste();
    }
    if (hjelpeReferanseRettBak == null ) {
      /* Dette skjer om listen var tom fra fr. */
      frsteElement = new ListeElement<Type>(nyttElement);
    } else {
      /*
       * Dette skjer dersom det var minst ett element i listen fra
       * fr. hjelpeReferanseRettBak refererer n til det siste
       * elementet.
       */
      hjelpeReferanseRettBak.setNeste(new ListeElement<Type>(nyttElement));
    }
  }

  /**
   * Sker etter et element i listen. Bruker equals() til sammenligning.
   */
  public boolean skEtterElement(Type skeElement) {
    ListeElement<Type> hjelpeReferanse = frsteElement;
    while (hjelpeReferanse != null) {
      if (hjelpeReferanse.getElement().equals(skeElement)) {
        return true;
      }
      hjelpeReferanse = hjelpeReferanse.getNeste();
    }
    return false;
  }

  /**
   * Sletter alle forekomster av elementet fra listen.
   * Bruker equals() for sammenligning.
   */
  public void slettElement(Type elementSomSkalSlettes) {
    ListeElement<Type> hjelpeReferanse = frsteElement;
    ListeElement<Type> hjelpeReferanseRettBak = null;
    /* Vi starter med  iterere oss framover i listen. */
    while (hjelpeReferanse != null) {
      if (hjelpeReferanse.getElement().equals(elementSomSkalSlettes)) {
          /*
           * Hjelpereferanse refererer n til et element som skal
           * slettes. Vi m ha spesialbehandling dersom dette er det
           * frste elementet i listen.
           */
          if (hjelpeReferanseRettBak != null) {
              hjelpeReferanseRettBak.setNeste(hjelpeReferanse.getNeste());
            } else {
              frsteElement = hjelpeReferanse.getNeste();
            }
            hjelpeReferanse = hjelpeReferanse.getNeste();
         } else {
            hjelpeReferanseRettBak = hjelpeReferanse;
            hjelpeReferanse = hjelpeReferanse.getNeste();
      }
    }
  }
}