/**
 * SubTre.java - "Programmering i Java", 4.utgave - 2009-07-01
 *
 * Klasse for delene av et binrt sketre. Subtrrne, inklusive
 * bladene, bestr av nye objekter av klassen.
 */

class SubTre {
  private SubTre hyreTre = null;
  private SubTre venstreTre = null;
  private SubTre forelder = null;
  private int verdi = 0;

  public SubTre(int verdi) {
    this.verdi = verdi;
  }

  public SubTre(int verdi, SubTre forelder) {
    this.verdi = verdi;
    this.forelder = forelder;
  }

  /**
   * Metoden setter inn en ny verdi i dette (sub)treet.
   */
  public void settInnVerdi(int nyVerdi) {
    /*
     * Dersom verdien for dette hjrnet er strre enn eller likden
     * nye, skal den nye verdien inn i venstre subtre.
     */
    if (verdi >= nyVerdi) {
      if (venstreTre != null) {
        venstreTre.settInnVerdi(nyVerdi);
      } else {
        venstreTre = new SubTre(nyVerdi, this);
      }
    } else {
      if (hyreTre != null) {
        hyreTre.settInnVerdi(nyVerdi);
      } else {
        hyreTre = new SubTre(nyVerdi, this);
      }
    }
  }

  /**
   * Metoden traverserer treet infiks og returnerer en tekst med
   * innholdet, separert med blanktegn.
   */
  public String toString () {
    String returStreng = "";
    if (venstreTre != null) {
      returStreng = venstreTre.toString() + " ";
    }
    returStreng = returStreng + verdi;
    if (hyreTre != null) {
      returStreng = returStreng + " " + hyreTre.toString();
    }
    return returStreng;
  }

  /**
   * Metoden returnerer true dersom den oppgitte verdien finnes i treet.
   */
  public boolean skEtterVerdi(int skeVerdi) {
    if (skeVerdi == verdi) {
      return true;
    }
    if (verdi > skeVerdi) {
      if (venstreTre != null) {
        return venstreTre.skEtterVerdi(skeVerdi);
      } else {
        return false;
      }
    } else {
      if (hyreTre != null) {
        return hyreTre.skEtterVerdi(skeVerdi);
      } else {
        return false;
      }
    }
  }
}