/**
 * Ansatt.java  - "Programmering i Java", 4.utgave - 2009-07-01
 *
 * Klassen beskriver en ansatt med nr, navn, skatteprosent og timelnn.
 * Det er mulig  endre skatteprosent og timelnn.
 * Det foretas ingen kontroll av at den nye skatteprosenten er under grensen.
 * Skattetrekk, netto- og bruttolnn kan regnes ut.
 */

class Ansatt {
  public static final double MAKS_SK_PROS = 60.0;

  private final int ansattnr;
  private final String navn;
  private double timelnn;
  private double skatteprosent = MAKS_SK_PROS;

  public Ansatt(int ansattnr, String navn, double timelnn) {
    this.ansattnr = ansattnr;
    this.navn = navn;
    this.timelnn = timelnn;
  }

  public Ansatt(int ansattnr, String navn) {
    this.ansattnr = ansattnr;
    this.navn = navn;
    this.timelnn = 0.0;
  }

  public int getAnsattnr() {
    return ansattnr;
  }

  public String getNavn() {
    return navn;
  }

  public double getTimelnn() {
    return timelnn;
  }

  public double getSkatteprosent() {
    return skatteprosent;
  }

  public void setTimelnn(double nyTimelnn) {
      timelnn = nyTimelnn;
  }

  public void setSkatteprosent(double nySkattepros) {
      skatteprosent = nySkattepros;
  }

  public double beregnBruttolnn(double antTimer) {
    return antTimer * timelnn;
  }

  public double beregnSkattetrekk(double antTimer) {
    return beregnBruttolnn(antTimer) * skatteprosent / 100.0;
  }

  public double beregnNettolnn(double antTimer) {
    return beregnBruttolnn(antTimer) - beregnSkattetrekk(antTimer);
  }

  public String toString() {
    return "Ansattnr.: " + ansattnr + ", navn: " + navn + ", timelnn: "
            + ", skatteprosent: " + skatteprosent;
  }
}