/**
 * Lonnsberegning2.java  - "Programmering i Java", 4.utgave - 2009-07-01
 *
 * Finner nettolnnen for ulike skatteprosenter for n ansatt.
 *
 * Filen inneholder to klasser:
 * LonnsBGS: Klassen srger for all kommunikasjon p detaljniv mellom brukeren
 * og et ansattobjekt for en helt spesiell anvendelse.
 * Lonnsberegning2: Inneholder main(), som viser hovedflyten i programmet.
 */

import static javax.swing.JOptionPane.*;

class Lonnsberegning2 {
  public static void main(String[] args) {
    final double ANT_TIMER = 20.0;
    Ansatt ansatt = new Ansatt(12345, "Anne Vik");
    LonnsBGS bgs = new LonnsBGS(ansatt);
    String timelnnLest = bgs.lesTimelnnSomTekst();
    while (timelnnLest != null) {
      bgs.registrerNyTimelnn(timelnnLest);
      bgs.registrerNySkattepros();
      double nettolnn = ansatt.beregnNettolnn(ANT_TIMER);
      bgs.skrivUtNettolnn(nettolnn);
      timelnnLest = bgs.lesTimelnnSomTekst();
    }
  }
}

class LonnsBGS {
  private final Ansatt enAnsatt;

  public LonnsBGS(Ansatt ansatt) {
    this.enAnsatt = ansatt;
  }

  public String lesTimelnnSomTekst() {
    return showInputDialog("Oppgi timelnn, avslutt med Esc: ");
  }

  public void registrerNyTimelnn(String lnn) {
    double timelnn = Double.parseDouble(lnn);
    enAnsatt.setTimelnn(timelnn);
  }

  public void registrerNySkattepros() {
    double maks = Ansatt.MAKS_SK_PROS;
    double nyPros = lesDesimaltall("Ny skatteprosent, maks " + maks + ": ");
    while (nyPros < 0.0 || nyPros > maks) {
      String melding = "Du skrev: " + nyPros + ", det er ikke gyldig skatteprosent.";
      melding += "\nSkriv et tall i intervallet 0,0 - " + maks+ ": ";
      nyPros = lesDesimaltall(melding);
    }
    enAnsatt.setSkatteprosent(nyPros);
  }

  public void skrivUtNettolnn(double netto) {
    java.util.Formatter formaterer =  new java.util.Formatter(); // formaterer utskriften
    formaterer.format("%.2f", netto);
    String utskrift = "Nettolnn kr " + formaterer.toString();
    showMessageDialog(null, utskrift);
  }

  /*
   * Hjelpemetode p lavere niv
   */
  private double lesDesimaltall(String ledetekst) {
    String tallLest = showInputDialog(ledetekst);
    return Double.parseDouble(tallLest);
  }
}

/* Kjring av programmet:
Oppgi timelnn, avslutt med Esc: 100
Ny skatteprosent, maks 60.0: 50
Nettolnn, kr 1000,00
Ny timelnn: 300
Ny skatteprosent, maks 60.0: 10
Nettolnn, kr 5400,00
*/